#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <set>

using namespace std;

const int NMAX=1000000;
const int MAXVAL = 1000000000;

int a[NMAX];

//аргументы: количество_запросов, начальное_значение_для_srand
int main (int, char *argv[]) {
  int n = atoi(argv[1]) / 2;
  int srand_init = atoi(argv[2]);
  srand(srand_init);
  cout << n*2+1 << endl;
  a[n-1]=1;
  int t=1;
  for (int i=n-2; i>=0; i--){
    a[i] = a[i+1]+t;
    if (a[i] > MAXVAL) {
      cerr << "too large number";
      exit(1);
    }
    t++;
  }
  for (int i=0; i<100; i++ ){
    int i1 = rand()*rand() % n;
    int i2 = rand()*rand() % n;
    int t = a[i1]; a[i1] = a[i2]; a[i2] = t;
  }
  cout << "ADD 999999999" << endl;
  for (int i=0; i<n; i++) {
    cout << "ADD " << a[i] << endl;
    cout << "FIND" << endl;
  }

  return 0;
}

